
module.exports = function(RED) {
    "use strict";
    var namevalueNode = function(n) {
        RED.nodes.createNode(this,n);
        this.psep = n.psep;
        this.vsep = n.vsep;
        var node = this;
        // foo=bar,a=b,y=zed
        node.on("input", function(msg) {
            if (msg.payload !== undefined && typeof msg.payload === "string") {
                var m = {};
                var b = msg.payload.split(node.psep);
                for (var i=0; i<b.length; i++) {
                    var k = b[i].split(node.vsep);
                    m[k[0]] = k[1];
                }
                msg.payload = m;
            }
            // {"foo":"bar","a":"b","y":"zed"}
            else if (msg.payload !== undefined && msg.payload.constructor === Object) {
                var m = "";
                for (var p in msg.payload) {
                    if (msg.payload.hasOwnProperty(p)) {
                        if (typeof msg.payload[p] === "object") {
                            m = m + p + node.vsep + JSON.stringify(msg.payload[p]) + node.psep;
                        }
                        else {
                            m = m + p + node.vsep + msg.payload[p].toString() + node.psep;
                        }
                    }
                }
                if (m.length > 0) { m = m.slice(0,-1); }
                msg.payload = m;
            }
            node.send(msg);
        });
    }
    RED.nodes.registerType("namevalue",namevalueNode);
}
